package examples;

import com.DeathByCaptcha.AccessDeniedException;
import com.DeathByCaptcha.Client;
import com.DeathByCaptcha.HttpClient;
import com.DeathByCaptcha.SocketClient;
import com.DeathByCaptcha.Captcha;
import java.io.IOException;

public class ExampleGetBalance
{
	public static void getBalance(Client client){
        client.isVerbose = true;
        try {
            try {
                System.out.println("Your balance is " + client.getBalance() + " US cents");
            } catch (IOException e) {
                System.out.println("Failed fetching balance: " + e.toString());
                return;
            }

        } catch (com.DeathByCaptcha.Exception e) {
            System.out.println(e);
        }
	}

    public static void main(String[] args)
        throws Exception
    {
        // Put your DBC username & password here:
        Client client;
        if(args.length < 3){
        	System.out.println("We must pass the following arguments");
        	System.out.println("<CLIENT-TYPE> (socket, http)");
        	System.out.println("<AUTH-TYPE> (username, token)");
        	System.out.println("if username used the need to pass username password");
        	System.out.println("if token used need to pass authtoken");
        	System.out.println("Examples:");
        	System.out.println("mvn exec:java -Dexec.mainClass=\"examples.getBalance\" -Dexec.args=\"socket username myusername mypassword\"");
        	System.out.println("mvn exec:java -Dexec.mainClass=\"examples.getBalance\" -Dexec.args=\"http token mytoken\"");
        	return;
        }

        if(args[0].equals("socket")){
        	System.out.println("Using socket connection");
        }else if(args[0].equals("http")){
        	System.out.println("Using http connection");
        }else{
        	System.out.println("Unknown connection, plese verify the parameters");
        	return;
        }

        if(args[1].equals("username")){
        	System.out.println("Using username/password authentication");
        	if (args.length != 4){
        		System.out.println("Wrong parameter number");
        		return;
        	}
        }else if(args[1].equals("token")){
        	System.out.println("Using token authentication");
        	if (args.length != 3){
        		System.out.println("Wrong parameter number");
        		return;
        	}	
        }else{
        	System.out.println("Unknown authentication, plese verify the parameters");
        	return;
        }

        if(args[0].equals("http")){
	        // using http API
	        if(args.length == 4){
	            client = (Client)(new HttpClient(args[2], args[3]));
	            getBalance(client);
	        }else if(args.length == 3){
	            client = (Client)(new HttpClient(args[2]));
	            getBalance(client);
	        }else{
	            System.out.println("Wrong number of arguments");
	            System.out.println("You must use username/password combination");
	            System.out.println("Or API key");
	            return;
	        }
    	}else if(args[0].equals("socket")){
	        // using sockets API
	        if(args.length == 4){
	            client = (Client)(new SocketClient(args[2], args[3]));
	            getBalance(client);
	        }else if(args.length == 3){
	            client = (Client)(new SocketClient(args[2]));
	            getBalance(client);
	        }else{
	            System.out.println("Wrong number of arguments");
	            System.out.println("You must use username/password combination");
	            System.out.println("Or API key");
	            return;
	        }
    	}
    }
}
